pipeline {
  environment {
        registry = "sharifdocker123/heartihealthproject"
        registryCredential = 'docker_hub_sharif'
        dockerImage = ''
    }
  agent any
  stages{
    stage('Git'){
      steps{
        git "https://gitlab.com/sk.sharif1998/HeartiHealthProject.git"
      }
    }
    stage ('Build') {
      steps{
        echo "Building Project"
        nodejs('nodejs') {
         sh 'npm install'
         sh 'npm run build'
        }
      }
    }
 
    stage ('Build Docker Image') {
      steps{
        echo "Building Docker Image"
        script {
          dockerImage = docker.build registry + ":$BUILD_NUMBER"
        }
      }
    }
    stage ('Push Docker Image') {
      steps{
        echo "Pushing Docker Image"
        script {
          docker.withRegistry( '', registryCredential ) {
              dockerImage.push()
              dockerImage.push('latest')
          }
        }
      }
    }
    stage ('Deploy to Dev') {
      steps{
        echo "Deploying to Dev Environment"
         sh "docker rm -f heartihealthproject || true"
         sh "docker run -d --name=heartihealthproject -p 4200:4200 sharifdocker123/heartihealthproject"
      }
    }
  }
}